//---------------------------------------------------------------------------

#ifndef uCalcRPNH
#define uCalcRPNH

#include <pgxml.h>
#include <astack.h>

#include "ucalcobj.h"

//#include "MathStack.h"
//#include "uStack.h"
//---------------------------------------------------------------------------
class TCalcRPN : public TCalcObject
{
   private:
   //TMathStack* Stack;
   atomstack* Stack;
   bool DotPressed;
   bool IsError;
   TCalcOperation Opr;

   int CStackPos;
   int CNewStackPos;
   int CStackDispPos;
   AnsiString SClipboard;
   //TClipboard* Clip;

   //void ToInputLine( TMathStackOp Opr );

   public:
   int Precision;

   TCalcRPN( TCalc* AOwner );
   ~TCalcRPN( void );

   //void SetAngleMeasure( TAngleMeasure Value );

   void SetMode( int AMode );

   void Refresh( void );
   void Activate( void );
   void ExecAction( TButtonAction& Action );
   void ExecActionMode1( TButtonAction& Action );
   void InputChar( int Char );
   void ExecMenuCmd( int AMenuCmd = -1 );

   void BackSpace( void );
   //void ErrMsg( AnsiString Message );
	bool StoreResult( int Index );

   bool Push( AnsiString p );
   bool Eval( TButtonAction Action );
   void Eval( TStackFunc Func );

   void SaveState( FILE* file );
   void TCalcRPN::SaveState( xmlnode* node );
	
	void LoadState( FILE* file );
	void LoadState( xmlnode* node );
};
//---------------------------------------------------------------------------
#endif
